#include <windows.h>
extern "C"
{
#include "vddsvc.h"
}
extern "C"
BOOL __stdcall VDDInitialize(PVOID DllHandle, ULONG Reason, PCONTEXT Context)
{
 return TRUE;
}

extern "C"
VOID __stdcall VDDRegisterInit()
{
 static BOOLEAN Initialized = FALSE;
 OutputDebugString("VDDRegisterInit");
 if(Initialized)
 {
  setCF(0);
  return;
 }
 
 Initialized = TRUE;
 setCF(0);
}

extern "C"
VOID __stdcall VDDDispatch()
{
 LPWORD  VdmWordPtr;
 WORD    VdmAX;
 WORD    VdmInt;
 ULONG   VdmAddress;
 static  CHAR buf[256];

    // The TSR pushes AX on the stack. Pick up the value here
 VdmAddress = (getSS() << 16) | getSP();
 VdmWordPtr = (LPWORD) GetVDMPointer(VdmAddress, 4, FALSE);
 VdmAX  = VdmWordPtr[0];
 VdmInt = VdmWordPtr[1];
 FreeVDMPointer(VdmAddress, 4, VdmWordPtr, FALSE);
 setAX (VdmAX); //restore AX
 Sleep(1);
 wsprintf(buf, "VDDDispatch int=0x%02X, ax=0x%04X", VdmInt, VdmAX);
 OutputDebugString(buf);
}
